#include <bit>

namespace fcf {
namespace net {
  void initialize();
  void uninitialize();

  template <typename Ty>
  inline Ty le_to_cpu(Ty a_value){
    if constexpr (std::endian::native == std::endian::little)
      return a_value;
    Ty result;
    for(size_t i = 0; i < sizeof(result); ++i)
      ((char*)&result)[i] = ((char*)&a_value)[sizeof(result) - i - 1];
    return result;
  }

}
}
