#ifdef WIN32
#pragma warning(disable:4996)
#endif



#include <cstring>
#include <string>
#include <codecvt>
#include <filesystem>
#include "string.hpp"

namespace fcf {
  
  int find_str(const char* a_data, int a_offset, int a_end, const char* a_sought) {
    int soughtlen = (int)std::strlen(a_sought);
    int lst = -1;
    for(int pos = a_offset; pos < a_end; ++pos){
      if (a_data[pos] == a_sought[0]){
        bool eq = true;
        int cpos = pos + 1;
        for(int i = 1; i < soughtlen; ++i, ++cpos){
          if (cpos >= a_end || a_sought[i] != a_data[cpos]){
            eq = false;
            break;
          }
        }
        if (eq)
          return pos;
      }
    }
    return -1;
  }

  inline bool char_eqi(char a_left, char a_right) {
    if (a_left == a_right)
      return true;
    if (a_left >= 'A' && a_left <= 'Z') {
      a_left = 'a' + (a_left - 'A');
      if (a_right >= 'A' && a_right <= 'Z')
        a_right = 'a' + (a_right - 'A');
      return a_left == a_right;
    }
    else if (a_right >= 'A' && a_right <= 'Z') {
      a_right = 'a' + (a_right - 'A');
      return a_left == a_right; 
    }
    return false;
  }

  int find_stri(const char* a_data, int a_offset, int a_end, const char* a_sought) {
    int soughtlen = (int)std::strlen(a_sought);
    int lst = -1;
    for(int pos = a_offset; pos < a_end; ++pos){
      if (char_eqi(a_data[pos], a_sought[0])){
        bool eq = true;
        int cpos = pos + 1;
        for(int i = 1; i < soughtlen; ++i, ++cpos){
          if (cpos >= a_end || !char_eqi(a_sought[i], a_data[cpos])){
            eq = false;
            break;
          }
        }
        if (eq)
          return pos;
      }
    }
    return -1;
  }

  std::wstring utf8str_to_wstr_cstr(const char* a_str) {
    #ifdef WIN32
      return std::wstring((const wchar_t*)std::wstring_convert<std::codecvt_utf8_utf16<char16_t>, char16_t>().from_bytes(a_str).c_str());
    #else
      std::wstring_convert<std::codecvt_utf8<char32_t>, char32_t> convert;
      return std::wstring((const wchar_t*)convert.from_bytes(a_str).c_str());
    #endif
  }

  std::string wstr_to_utf8str_cstr(const wchar_t* a_str) {
    #ifdef WIN32
      std::u16string wstr((const char16_t*)a_str);
      return std::string((const char*)std::wstring_convert<std::codecvt_utf8_utf16<char16_t>, char16_t>().to_bytes(wstr).c_str());
    #else
      std::wstring_convert<std::codecvt_utf8<char32_t>, char32_t> convert;
      return std::string((const char*)convert.to_bytes((const char32_t*)a_str).c_str());  
    #endif
  }

} // fcf namespace
