#include <iostream>
#include <global_configuration.hpp>

void application::global_configuration_t::set_values(boost::property_tree::ptree& a_ptree){
  std::vector< std::pair<unsigned short int, unsigned short int> > ports;
  boost::property_tree::ptree::assoc_iterator it = a_ptree.find("freePorts");
  if (it != a_ptree.not_found()){
    for(boost::property_tree::ptree::iterator child_it = it->second.begin(); child_it != it->second.end(); ++child_it){
      try {
        boost::property_tree::ptree::iterator start = child_it->second.begin();
        if (start == child_it->second.end())
          continue;
        boost::property_tree::ptree::iterator end = ++child_it->second.begin();
        if (end == child_it->second.end())
          continue;

        unsigned short int p1 = std::stoi(start->second.data());
        unsigned short int p2 = std::stoi(end->second.data());
        if (!p1 || !p2)
          continue;
        ports.push_back({p1, p2});
      } catch(...) {
      }
    }
  }
  if (!ports.empty())
    this->free_ports = ports;
}
